/*=======================================================================
This is an jumpjump game for X.

THIS program is under the GPL.

This program requires xforms!

By any kind of problem contact me please under the address:
  nihil@makosteszta.sote.hu
  
    Have a lot of fun!
    
          nihil
=======================================================================*/
          
#include <forms.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include "rnd.h"
#include "infob.h"
#include "texts.h"
#include "xpm/xpms.h"
 
/*#####################################################################
#   -level <nr>       [def=1,min=1,max=6]
#   -version
#   -nopicture
#####################################################################*/ 

/*---------------------------------------------------------------------*/

#define BOX_XPM_TYP  1
#define BOX_NORM_TYP 2


#define MY_BOX_D   2
#define MY_BOX_X  10
#define MY_BOX_Y  60
#define MY_BOX_W  48
#define MY_BOX_H  48
 
#define STAR_MIX_BOX_NR 17
#define BOX_NR          21

typedef struct { int  x,y,w,h,up,right,down,left; } box_size;
const box_size box_array[ BOX_NR ] =
{ 
  { MY_BOX_X+0*(MY_BOX_W+MY_BOX_D), MY_BOX_Y+0*(MY_BOX_H+MY_BOX_D), MY_BOX_W, MY_BOX_H, -1,  1, 15, -1 }, /*00*/
  { MY_BOX_X+1*(MY_BOX_W+MY_BOX_D), MY_BOX_Y+0*(MY_BOX_H+MY_BOX_D), MY_BOX_W, MY_BOX_H, -1,  2, -1,  0 }, /*01*/
  { MY_BOX_X+2*(MY_BOX_W+MY_BOX_D), MY_BOX_Y+0*(MY_BOX_H+MY_BOX_D), MY_BOX_W, MY_BOX_H, -1,  3, 16,  1 }, /*02*/
  { MY_BOX_X+3*(MY_BOX_W+MY_BOX_D), MY_BOX_Y+0*(MY_BOX_H+MY_BOX_D), MY_BOX_W, MY_BOX_H, -1,  4, -1,  2 }, /*03*/
  { MY_BOX_X+4*(MY_BOX_W+MY_BOX_D), MY_BOX_Y+0*(MY_BOX_H+MY_BOX_D), MY_BOX_W, MY_BOX_H, -1, -1,  5,  3 }, /*04*/

  { MY_BOX_X+4*(MY_BOX_W+MY_BOX_D), MY_BOX_Y+1*(MY_BOX_H+MY_BOX_D), MY_BOX_W, MY_BOX_H,  4, -1,  6, -1 }, /*05*/
  { MY_BOX_X+4*(MY_BOX_W+MY_BOX_D), MY_BOX_Y+2*(MY_BOX_H+MY_BOX_D), MY_BOX_W, MY_BOX_H,  5, -1,  7, 20 }, /*06*/
  { MY_BOX_X+4*(MY_BOX_W+MY_BOX_D), MY_BOX_Y+3*(MY_BOX_H+MY_BOX_D), MY_BOX_W, MY_BOX_H,  6, -1,  8, -1 }, /*07*/

  { MY_BOX_X+4*(MY_BOX_W+MY_BOX_D), MY_BOX_Y+4*(MY_BOX_H+MY_BOX_D), MY_BOX_W, MY_BOX_H,  7, -1, -1,  9 }, /*08*/
  { MY_BOX_X+3*(MY_BOX_W+MY_BOX_D), MY_BOX_Y+4*(MY_BOX_H+MY_BOX_D), MY_BOX_W, MY_BOX_H, -1,  8, -1, 10 }, /*09*/
  { MY_BOX_X+2*(MY_BOX_W+MY_BOX_D), MY_BOX_Y+4*(MY_BOX_H+MY_BOX_D), MY_BOX_W, MY_BOX_H, 18,  9, -1, 11 }, /*10*/
  { MY_BOX_X+1*(MY_BOX_W+MY_BOX_D), MY_BOX_Y+4*(MY_BOX_H+MY_BOX_D), MY_BOX_W, MY_BOX_H, -1, 10, -1, 12 }, /*11*/
  { MY_BOX_X+0*(MY_BOX_W+MY_BOX_D), MY_BOX_Y+4*(MY_BOX_H+MY_BOX_D), MY_BOX_W, MY_BOX_H, 13, 11, -1, -1 }, /*12*/

  { MY_BOX_X+0*(MY_BOX_W+MY_BOX_D), MY_BOX_Y+3*(MY_BOX_H+MY_BOX_D), MY_BOX_W, MY_BOX_H, 14, -1, 12, -1 }, /*13*/
  { MY_BOX_X+0*(MY_BOX_W+MY_BOX_D), MY_BOX_Y+2*(MY_BOX_H+MY_BOX_D), MY_BOX_W, MY_BOX_H, 15, 19, 13, -1 }, /*14*/
  { MY_BOX_X+0*(MY_BOX_W+MY_BOX_D), MY_BOX_Y+1*(MY_BOX_H+MY_BOX_D), MY_BOX_W, MY_BOX_H,  0, -1, 14, -1 }, /*15*/


  { MY_BOX_X+2*(MY_BOX_W+MY_BOX_D), MY_BOX_Y+1*(MY_BOX_H+MY_BOX_D), MY_BOX_W, MY_BOX_H,  2, -1, 17, -1 }, /*16*/
  { MY_BOX_X+2*(MY_BOX_W+MY_BOX_D), MY_BOX_Y+2*(MY_BOX_H+MY_BOX_D), MY_BOX_W, MY_BOX_H, 16, 20, 18, 19 }, /*17*/
  { MY_BOX_X+2*(MY_BOX_W+MY_BOX_D), MY_BOX_Y+3*(MY_BOX_H+MY_BOX_D), MY_BOX_W, MY_BOX_H, 17, -1, 10, -1 }, /*18*/

  { MY_BOX_X+1*(MY_BOX_W+MY_BOX_D), MY_BOX_Y+2*(MY_BOX_H+MY_BOX_D), MY_BOX_W, MY_BOX_H, -1, 17, -1, 14 }, /*19*/
  { MY_BOX_X+3*(MY_BOX_W+MY_BOX_D), MY_BOX_Y+2*(MY_BOX_H+MY_BOX_D), MY_BOX_W, MY_BOX_H, -1,  6, -1, 17 }, /*20*/
};

typedef int       BoxWerteArrayTyp[ BOX_NR ];
typedef FL_OBJECT *BoxObjArrayTyp[BOX_NR];


#define COLOR_NR        10
#define NORMAL_BG_COLOR FL_LEFT_BCOL
#define ACT_BG_COLOR    FL_YELLOW
#define ZERO_COLOR      FL_DOGERBLUE

const FL_PD_COL color_array[ COLOR_NR ] =
{   
    FL_RED,
    FL_DARKCYAN,/*FL_GREEN,*/
    FL_ORCHID, /*FL_YELLOW,*/
    FL_BLUE,
    FL_MAGENTA,
    FL_DARKTOMATO, /*FL_CYAN,*/    
    FL_TOMATO,
    FL_INDIANRED,
    FL_SLATEBLUE,    
    FL_PALEGREEN
};


typedef struct { char *name[LANGUAGES_NR];
                 int  mix_nr, min_nr, max_nr ;
} tb_level;

#define TB_LEVEL_NR 6
const tb_level table_level[ TB_LEVEL_NR ] =
{ 
  {  {"Ultra Light", "Csecsem"   },  30,  15,  30 },
  {  {"Light",       "vodas",    },  60,  30,  60 },
  {  {"Beginner",    "Iskols"    },  90,  60,  80 },
  {  {"Intermediate","Dik"       }, 120,  80, 100 },
  {  {"Litle Expert","Tanr"      }, 150, 100, 120 },
  {  {"Expert",      "Professzor" }, 200, 120, 999 }
};
  


#define TB_BACK_STEP_NR 255
typedef int BackStepArrayTyp[ TB_BACK_STEP_NR ];


/*---------------------------------------------------------------------*/


  BoxObjArrayTyp   my_box;
  BoxWerteArrayTyp box_var_wert;


/*---------------------------------------------------------------------*/

#define USEPRT(msg) fprintf(stderr, msg)

void
Usage(void)
{
    USEPRT("Usage: xjumpjump [options]\n\n");
    USEPRT("Options:\n");
    USEPRT("  -level <levelnr>       [default=1, min=1, max=6]\n");
    USEPRT("  -version\n");
    USEPRT("  -nopicture\n");
    exit(1);
}
                                                        
/*---------------------------------------------------------------------*/

int p_get_box_nr( FL_OBJECT *obj, BoxObjArrayTyp objaray )
{ int a;
  int nr;
  nr=-1;
  for ( a=0; a<BOX_NR; a++ ) {
    if ( objaray[a] == &*obj ) { nr=a;};
  };
  return nr;
}

/*---------------------------------------------------------------------*/

void p_mark_box( FL_OBJECT *ob, int nr, int xpm_nr, int box_typ )
{ char st[4];

  if (box_typ==BOX_NORM_TYP)
    { sprintf( st, "%1d", nr % 10 );
      fl_set_object_label( ob, st);
      fl_set_object_lcol( ob, color_array[ nr % 10 ] );
      if ( nr==0 )
        { fl_set_object_color( ob, ZERO_COLOR, FL_MCOL ); }
      else if ( nr>9 )
        { fl_set_object_color( ob, ACT_BG_COLOR, FL_MCOL ); }
      else   
        { fl_set_object_color( ob, NORMAL_BG_COLOR, FL_MCOL ); }
    }
    else
    { fl_free_pixmapbutton_pixmap( ob );
      fl_set_pixmapbutton_data( ob, xpms[xpm_nr][nr] );
    };
};

/*---------------------------------------------------------------------*/

void p_box_table_mix( BoxWerteArrayTyp bw, int schritte, int min, int max )
{ int x,y, bnr, sum;

  do
  {
    for (x=0; x<BOX_NR; x++ )
    { bw[x]=0; };

    bnr=STAR_MIX_BOX_NR;
    for (y=schritte; y>0; y-- )
    {  switch (rnd(4))
       { case 0: if (box_array[bnr].up!=-1) 
                 { bnr=box_array[bnr].up;
                   if (bw[bnr]<(COLOR_NR-1)) bw[bnr]++;
                 };
                 break;
         case 1: if (box_array[bnr].right!=-1) 
                 { bnr=box_array[bnr].right;
                   if (bw[bnr]<(COLOR_NR-1)) bw[bnr]++;
                 };
                 break;
         case 2: if (box_array[bnr].down!=-1) 
                 { bnr=box_array[bnr].down;
                   if (bw[bnr]<(COLOR_NR-1)) bw[bnr]++;
                 };
                 break;
         case 3: if (box_array[bnr].left!=-1) 
                 { bnr=box_array[bnr].left;
                   if (bw[bnr]<(COLOR_NR-1)) bw[bnr]++;
                 };
                 break;
       }
    };

    sum=0;
    for (x=0; x<BOX_NR; x++ ) { sum+=bw[x]; };

  } while ( (sum>min) && (sum<max) );


};


/*---------------------------------------------------------------------*/

int preemptive_handler( FL_OBJECT *ob, int event,
                        FL_Coord mx, FL_Coord my, int key, void *xev)
{
  if (event==FL_ENTER)
    { if ( box_var_wert[ p_get_box_nr( ob, my_box )]<1 )
        { fl_set_cursor(FL_ObjWin(ob), /*XC_dot*/ -1 ); }
        else
        { fl_set_cursor(FL_ObjWin(ob), XC_hand2 ); };
      return( FL_PREEMPT /* 0 */ );
    }

  return(0);
}

/*---------------------------------------------------------------------*/

int post_handler(FL_OBJECT *ob, int event,
                 FL_Coord mx, FL_Coord my, int key, void *xev)
{

  if (event==FL_LEAVE)
    { fl_set_cursor(FL_ObjWin(ob), -1 );
      return ( FL_PREEMPT );
    }

  return(0);
}

/*---------------------------------------------------------------------*/

int main(int ac, char *av[])
{
  int              ax;
  char             *arg;

  Display          *dpy;
  FL_FORM          *my_form;
  FL_OBJECT        *ende_but;
  FL_OBJECT        *new_but;  
  FL_OBJECT        *init_but;  
  FL_OBJECT        *info_but;  
  FL_OBJECT        *level_but;
  FL_OBJECT        *back_but;
  FL_OBJECT        *pic_but;  

  int              Level = 1;
  FL_OBJECT        *obj;
  int              x, sum, step;
  BoxWerteArrayTyp box_init_wert;
  int              act_box, old_act_box;
  int              init_game = 1;
  char             st[64];

  BackStepArrayTyp BackStepArray;
  int              BackStepNr;

  int              xpm_selection = 1;
  int              box_typ = BOX_XPM_TYP;


  /*~~~ Argumentums Auswerten ~~~*/
  p_set_language();
  dpy = fl_initialize(&ac, av, texts[language][NR_MY_PRGNAME], 0, 0); 

  for (ax=1; ax<ac; ax++) 
  { arg = av[ax];

    if (strcmp(arg, "-level") == 0) 
    { if ( (ax+1) >= ac ) { Usage(); }
      Level = strtol(av[++ax], (char **)NULL,0);
      if ( (Level<1) || (Level>6) ) { Usage(); }
    }
    else if (strcmp(arg, "-nopicture") == 0) 
    { box_typ = BOX_NORM_TYP;
    }
    else if (strcmp(arg, "-version") == 0) 
    { printf("\nThis is %s\n\n", texts[language][NR_VERSION] );
      exit(0);
    }
    else 
    { Usage();
    }
  }

  /*....................................*/

  my_form = fl_bgn_form(FL_NO_BOX,370,320);
  init_rnd();

  /*....................................*/

  obj = fl_add_box(FL_BORDER_BOX,0,0,370,50,"");
  fl_set_object_color(obj,FL_DARKGOLD,FL_COL1);
  fl_set_object_lcol(obj, FL_BLACK);
  obj = fl_add_box(FL_NO_BOX,0,0,310,50, texts[language][NR_MY_TITLE]);
  fl_set_object_lsize(obj,FL_HUGE_SIZE);
  fl_set_object_lstyle(obj, FL_BOLD_STYLE);
  fl_set_object_lcol(obj, FL_BLACK);
  obj = fl_add_box(FL_NO_BOX,270,0,100,50, texts[language][NR_MY_TITLE2] );
  fl_set_object_lcol(obj, FL_BLACK);

  obj = fl_add_box(FL_BORDER_BOX,0,50,270,270,"");
  fl_set_object_color(obj,FL_SLATEBLUE,FL_COL1);

  obj = fl_add_box(FL_BORDER_BOX,270,50,100,270,"");
  fl_set_object_color(obj,FL_DARKCYAN,FL_COL1);

  new_but=fl_add_button(FL_NORMAL_BUTTON,  280,  65+(0*35), 80, 30,
                        texts[language][NR_STR_BUT_NEW] );
  fl_set_object_lsize(new_but,FL_NORMAL_SIZE);

  init_but=fl_add_button(FL_NORMAL_BUTTON, 280,  65+(1*35), 80, 30, 
                         texts[language][NR_STR_BUT_INIT] );
  fl_set_object_lsize(init_but,FL_NORMAL_SIZE);

  back_but=fl_add_button(FL_NORMAL_BUTTON, 280,  65+(2*35), 80, 30,
                         texts[language][NR_STR_BUT_BSTEP] );
  fl_set_object_lsize(back_but,FL_NORMAL_SIZE);

  level_but=fl_add_menu( FL_PULLDOWN_MENU, 280,  65+(3*35), 80, 30, 
                         texts[language][NR_STR_BUT_LEVEL] );
  fl_set_object_lsize(level_but,FL_NORMAL_SIZE);
  fl_show_menu_symbol( level_but, 1);
  fl_set_object_boxtype( level_but, FL_UP_BOX);

  pic_but=fl_add_menu( FL_PULLDOWN_MENU, 280,    65+(4*35), 80, 30, 
                       texts[language][NR_STR_BUT_PIC] );
  fl_set_object_lsize(pic_but,FL_NORMAL_SIZE);
  fl_show_menu_symbol( pic_but, 1);
  fl_set_object_boxtype( pic_but, FL_UP_BOX);

  info_but=fl_add_button(FL_NORMAL_BUTTON, 280,  65+(5*35), 80, 30, 
                         texts[language][NR_STR_BUT_INFO] );
  fl_set_object_lsize(info_but,FL_NORMAL_SIZE);

  ende_but=fl_add_button(FL_NORMAL_BUTTON, 280,  65+(6*35), 80, 30, 
                         texts[language][NR_STR_BUT_ENDE] );
  fl_set_object_lsize(ende_but,FL_NORMAL_SIZE);

  /*....................................*/

  for ( x=0; x<TB_LEVEL_NR; x++ )
  { strcpy( st, table_level[x].name[language] );
    strcat( st, "%r1" );
    fl_addto_menu( level_but, st );
  }
  for ( x=1; x<=TB_LEVEL_NR; x++ )
  { if ( x == Level )
    { fl_set_menu_item_mode( level_but, x, FL_PUP_CHECK | FL_PUP_RADIO); }
    else
    { fl_set_menu_item_mode( level_but, x, FL_PUP_RADIO); };
  }

  /*....................................*/

  if ( box_typ == BOX_XPM_TYP ) 
    { sum=XPMS_SET; }
    else
    { sum=1;
      xpm_selection=0; }      

  for ( x=0; x<sum; x++ )
  { sprintf( st, texts[language][NR_STR_PIC_SET], x+1 );
    strcat( st, "%r1" );
    fl_addto_menu( pic_but, st );
  }
  for ( x=1; x<=sum; x++ )
  { if ( x == xpm_selection+1 )
    { fl_set_menu_item_mode( pic_but, x, FL_PUP_CHECK | FL_PUP_RADIO); }
    else
    { fl_set_menu_item_mode( pic_but, x, FL_PUP_RADIO); };
  }

  /*....................................*/


  for ( x=0; x<BOX_NR; x++)
  {
     if ( box_typ == BOX_XPM_TYP )
     { my_box[x]=fl_add_pixmapbutton( FL_NORMAL_BUTTON, 
                                      box_array[x].x, box_array[x].y,
                                      box_array[x].w, box_array[x].h, "");
     }
     else
     { my_box[x]=fl_add_button(       FL_NORMAL_BUTTON, 
                                      box_array[x].x, box_array[x].y,
                                      box_array[x].w, box_array[x].h, "");
       fl_set_object_boxtype( my_box[x], FL_BORDER_BOX );
       fl_set_object_color( my_box[x], FL_LEFT_BCOL, FL_MCOL);
       fl_set_object_lstyle( my_box[x], FL_FIXEDBOLD_STYLE);
       fl_set_object_lsize( my_box[x], FL_LARGE_SIZE );
     };
     fl_set_object_prehandler( my_box[x], preemptive_handler);
     fl_set_object_posthandler( my_box[x], post_handler);
     p_mark_box( my_box[x], 0, xpm_selection, box_typ );
  }

  /*....................................*/

  fl_end_form();
  fl_show_form( my_form, FL_PLACE_SIZE, FL_FULLBORDER, 
                texts[language][NR_MY_PRGNAME] );

  /*........................................................................*/


  do 
  { 
    if (init_game==1) p_box_table_mix( box_init_wert, table_level[Level-1].mix_nr,
                                       table_level[Level-1].min_nr, table_level[Level-1].max_nr );
    for (x=0;x<BOX_NR;x++) 
    { box_var_wert[x] = box_init_wert[x];
      p_mark_box( my_box[x], box_var_wert[x], xpm_selection, box_typ );
    };
    act_box=STAR_MIX_BOX_NR;
    old_act_box=act_box;
    p_mark_box( my_box[act_box], box_var_wert[act_box]+10, xpm_selection, box_typ );
    
    for (x=0;x<TB_BACK_STEP_NR;x++) BackStepArray[x]=-1;
    BackStepNr=0;
    BackStepArray[0]=act_box;
 
    do 
    { obj = fl_do_forms();
      step=0;

      if ( obj == ende_but ) 
      { fl_hide_form( my_form );
        return 0; };

      if ( obj == new_but ) 
      { init_game=1;
        break; };

      if ( obj == init_but ) 
      { init_game=0;
        break; };

      if ( obj == info_but ) 
      { p_create_form_info_browser();
        continue; };


      if ( obj == pic_but )
       { x=fl_get_menu(obj);
         fl_set_menu_item_mode( pic_but, xpm_selection+1, FL_PUP_RADIO);
         xpm_selection=x-1;
         fl_set_menu_item_mode( pic_but, xpm_selection+1, FL_PUP_CHECK | FL_PUP_RADIO);
         for ( x=0; x<BOX_NR; x++) {
           if (x!=act_box)  
            { p_mark_box( my_box[x], box_var_wert[x], xpm_selection, box_typ ); }
             else
            { p_mark_box( my_box[x], box_var_wert[x]+10, xpm_selection, box_typ ); };
         };
         continue;
       }


      if ( obj == level_but )
      { x=fl_get_menu(obj);
        fl_set_menu_item_mode( level_but, Level, FL_PUP_RADIO);
        Level=x;
        fl_set_menu_item_mode( level_but, Level, FL_PUP_CHECK | FL_PUP_RADIO);
        /*=== and new game ===*/
        init_game=1;
        break;
      };


      if ( obj==back_but )
      { if (BackStepNr>0)
        { box_var_wert[act_box]++;
          p_mark_box( my_box[act_box], box_var_wert[act_box], xpm_selection, box_typ );
          BackStepArray[BackStepNr--]=-1;
          act_box=BackStepArray[BackStepNr];
          p_mark_box( my_box[act_box], box_var_wert[act_box]+10, xpm_selection, box_typ );
          old_act_box=act_box;
        }
        continue;}

      
      act_box=p_get_box_nr( obj, my_box );

      if ( (old_act_box!=act_box) && 
           ( (box_array[old_act_box].up==act_box)   || (box_array[old_act_box].right==act_box) ||
             (box_array[old_act_box].down==act_box) || (box_array[old_act_box].left==act_box) )  &&
           (box_var_wert[act_box]!=0)  )
      { step=1;
        p_mark_box( my_box[old_act_box], box_var_wert[old_act_box], xpm_selection, box_typ );
        old_act_box=act_box;
        box_var_wert[act_box]--;
        p_mark_box( my_box[act_box], box_var_wert[act_box], xpm_selection, box_typ );
        if (box_var_wert[act_box]==0) 
          {  fl_set_cursor( FL_ObjWin(my_box[act_box]), -1 /*XC_dot*/ );
          }
        p_mark_box( my_box[act_box], box_var_wert[act_box]+10, xpm_selection, box_typ );

        if ( BackStepNr==(TB_BACK_STEP_NR-1) )
        { for (x=0;x<(TB_BACK_STEP_NR-1);x++) BackStepArray[x]=BackStepArray[x+1];
          BackStepArray[BackStepNr--]=-1;
        };
        BackStepArray[++BackStepNr]=act_box;
      }

      sum=0;
      for (x=0; x<BOX_NR; x++ ) { sum+=box_var_wert[x]; };
      if (sum==0)
      { fl_show_message( texts[language][NR_MY_TITLE], 
                         texts[language][NR_STR_CONGRAT], "");
        init_game=1;
        break;
      }
      else
      { sum=0;
        if (box_array[act_box].up!=-1) sum+= box_var_wert[box_array[act_box].up];
        if (box_array[act_box].down!=-1) sum+= box_var_wert[box_array[act_box].down];
        if (box_array[act_box].right!=-1) sum+= box_var_wert[box_array[act_box].right];
        if (box_array[act_box].left!=-1) sum+= box_var_wert[box_array[act_box].left];
        if ( (sum==0) && (step==1) )
        { fl_show_message( texts[language][NR_MY_TITLE], 
                           texts[language][NR_STR_PRACTISE], "");
          init_game=0;
          break;
        }
      }

    } while(1);
  } while(1);


  /*........................................................................*/

  fl_hide_form( my_form );
  return 0;
}

/*---------------------------------------------------------------------*/
